/*
 * (C) Copyright Ian D. Romanick 2007
 * All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * on the rights to use, copy, modify, merge, publish, distribute, sub
 * license, and/or sell copies of the Software, and to permit persons to whom
 * the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.  IN NO EVENT SHALL
 * AUTHORS, COPYRIGHT HOLDERS, AND/OR THEIR SUPPLIERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifdef _WIN32
# define WIN32_LEAN_AND_MEAN
# define _USE_MATH_DEFINES
# include <windows.h>
#endif

#include <stdio.h>
#include <GL/glew.h>

#include "SDL_text.h"

void draw_HUD(TTF_Font *font, float fps)
{
    glUseProgramObjectARB(0);
    glEnable(GL_TEXTURE_2D);
    SDL_GL_BeginText();
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_BLEND);
    glEnable(GL_BLEND);
    glBlendFunc(GL_ONE, GL_ONE);
    
    GLint view_port[4];
    glGetIntegerv(GL_VIEWPORT, view_port);


    char text[64];
    SDL_Color text_color = { 255, 255, 255, 255 };
    SDL_Rect rc_dest = { 
        0,
            view_port[3] -
            (TTF_FontLineSkip(font) + TTF_FontAscent(font) + 2),
        0,
        0
    };

    SDL_GL_RenderText("SPACE to animate model",
                      font, text_color, & rc_dest);

    rc_dest.y -= rc_dest.h;
    SDL_GL_RenderText("l to animate light",
                      font, text_color, & rc_dest);
#ifndef _WIN32
    snprintf(text, sizeof(text), "FPS: %.2f", fps);
#else
	sprintf_s(text, sizeof(text), "FPS: %.2f", fps);
#endif
    rc_dest.x = 0;
    rc_dest.y = 0;
    SDL_GL_RenderText(text, font, text_color, & rc_dest);

    glEnable(GL_DEPTH_TEST);
    glDisable(GL_BLEND);
    SDL_GL_EndText();
    glDisable(GL_TEXTURE_2D);
}
